# LHW Messages
Besides the standard messages we additionally need some messages of our own to send some specific information.

## Vision
Here messages used 
### Entity

|Type | Name   | Description   | Default|
|---|---|---|---|
|VisualSources| sources_types| The source of this message|*required*
|int|id|The assigned id of the object, e.g. tracked targets|*required*
|array[int]|sources|Previous sources|*required*
|array[int]|sources_id|The id which was originally given to this entity (same order as above).|*required*
|uint16[4]| bbox| [x1, y1, x2, y2] Top left and bottom right corner of the bounding box of the entity|*required*
|string| type|  Ex. person, apple, book. Right now there is no specific list of objects since this is subject to change.|*required*
|float32| confidence| The certainty in the detection, typically comes from Yolo. Useful if we want to ignore uncertain detections for example. |*required*

### Entities
Objects or people which are guaranteed to persist over time

|Type | Name   | Description   | Default |
|---|---|---|---|
|builtin_interfaces/Time | time | The time of detection. Right now this is set to the time when the corresponding image was sent from pepper. For more information see https://github.com/ros2/rcl_interfaces/blob/master/builtin_interfaces/msg/Time.msg| *required*
|VisualSources | sources_types | The source of this message | *required*
|uint8 | source | Where this message was produced | 0 | 
|uint16 | source_width | The size of the image that generated this message. Not sure why we use this. Possibly so that we get coordinates which are image size independent. |*required*
|uint16| source_height| See above comment| *required*
|List[Entity] |entities | A list containing all detected objeccts or people (entities) | *required*
