
class Editor {
    constructor(behaviour_definitions) {
      this.behaviour_definitions = behaviour_definitions
      this.active = false
    }
  
    updateBehaviour(behaviour_idx){
      var new_bahaviour = JSON.parse(JSON.stringify(this.behaviour_definitions[behaviour_idx] )) 
      this.active.label = new_bahaviour.label
      this.active.name = new_bahaviour.name
      this.active.input_data = new_bahaviour.input_data
      updateUI();
    }
  
    open(behaviour_id){
      this.active = sm.getBehaviourById(behaviour_id)
      updateUI();
    };
  
    save(){
      this.active.input_data.forEach((input, idx) => {
        this.active.input_data[idx].value = document.getElementById(input.data).value      
      })
      this.active = false
      updateUI()
    }
  
    getHTML(){
      if (this.active){
        
        var title = "<h2>Editing Behaviour</h2>";
  
        var selectBehaviour = '<select name="behaviours" onchange="editor.updateBehaviour(this.value)">';
        selectBehaviour += "<option value='' selected disabled hidden>" + this.active.label + "</option>"
        this.behaviour_definitions.forEach((behaviour, idx) => {
          selectBehaviour += "<option value=" + idx + ">" + behaviour.label + "</option>"
        }); 
        selectBehaviour += "</select>";
        
        var input_data_fields = ""
        if (this.active.name){
          this.active.input_data.forEach((input, idx) => {
            if (input.type == "yesno"){
              input_data_fields += "<div>" + input.label + "<select id=" + input.data + "> <option value='yes'>Yes</option> <option value='no'>No</option></select>"
            }
            else {
              if (!input.value){
                input.value = ""
              }
              input_data_fields += "<div> "+ input.label + ": <input type='text' id=" + input.data + " value='" + input.value + "' > </div>"
            }
          }); 
          
        }

        var button = "<button onclick='editor.save()'> Save </button>";

        return "<div>" + title + selectBehaviour + input_data_fields + button + " </div>"
        
      }
      else {
        return ""
      }
    }
  
  }