class StateMachine{
    constructor(behaviours) {
        this.behaviours = [new Behaviour(0, false, "Start")]
        this.active_idx = false
    }

    getBehaviourById(id){
        return this.behaviours.find(behaviour => behaviour.id == id);
    }

    addNext(parent){
        var new_id =  sm.behaviours.length
        this.behaviours.splice(parent + 1, 0, new Behaviour(new_id, parent));
        editor.open(new_id)
    };

    start(){
        this.active_idx = 1
        this.send_goal()
    }

    getDataValue(goal, name){
        var data = goal.input_data.find( input => input.data == name)
        if (!data){
            return ""
        }

        if (data.type == "yesno"){
            return data.value == "yes"
        }

        return data.value

    }

    send_goal() {
        var goal = this.behaviours[this.active_idx]
        goal_publisher.publish({
            what: goal.name,
            specificid: this.getDataValue(goal, "specificid"),
            specifictype: this.getDataValue(goal, "specifictype"),
            id: this.getDataValue(goal, "id"),
            type: this.getDataValue(goal, "type"),
            mapname:  this.getDataValue(goal, "mapname"),
            atstart: this.getDataValue(goal, "atstart"),
            behaviourtimeoutinsec: this.getDataValue(goal, "behaviourtimeoutinsec"),
        }); 
    }

    getHTML(){
        var html = ''
        html += "<button onclick='sm.start()'> START </button>";
        this.behaviours.forEach(behaviour => {
            html += behaviour.getHTML();
        })
        
        return html
    }
  
}