import time

import rclpy
from rclpy.action import ActionServer
from rclpy.node import Node

from lhw_interfaces.action import RotateRobot

class RotateRobotActionServer(Node):

    def __init__(self):
        super().__init__('rotate_robot_action_server')
        self._action_server = ActionServer(
            self,
            RotateRobot,
            'rotate_robot',
            self.execute_callback)

    def execute_callback(self, goal_handle):
        self.get_logger().info('Executing goal...')
        result = RotateRobot.Result()
        return result


def main(args=None):
    rclpy.init(args=args)

    rotate_robot_action_server = RotateRobotActionServer()

    rclpy.spin(rotate_robot_action_server)


if __name__ == '__main__':
    main()