from .behaviour import Behaviour
from std_msgs.msg import String
from lhw_interfaces.msg._result import Result

class Categorize(Behaviour):
    def __init__(self, node, args):
        super().__init__(node, args)
        self.node = node

        node.log.info("Categorize started")

        # ------------- State's properties --------------     
    
        self.state_done = False

        self.state_name = String()
        self.state_name.data = "CATEGORIZE"

        self.specific_id = args.id

        self.run_timer = self.node.create_timer(1, self.run) 

        self.state_done = False

        self.found_categories = []
        self.specific_entity_possible_categories = False

        specific_entity = self._get_entity(self.specific_id) 

        if specific_entity:
            self.specific_entity_possible_categories = self._get_categories_of_type(specific_entity["type"])
            print("possible: " + str(self.specific_entity_possible_categories))
        else:
            print("ERROR: Specific object hasn't been found yet")

    def run(self):  
        if self.state_done or self._behaviour_timeout():
            self.run_timer.cancel()
            self.send_result()
            return

        if not self.specific_entity_possible_categories:
            self.run_timer.cancel()
            self.send_result(success=False)
            return

        for category in self.specific_entity_possible_categories:
            if category in self.found_categories:
                
                self.state_done = True
    
    def entities_callback(self, data):
        
        for entity in data.entities:

            entity_info = {}
            entity_info["id"] = entity.id
            entity_info["type"] = entity.type
            #Fix this:
            entity_info["position"] = {"x": 2.0, "y": 6.0, "z": 1.0}
            self._add_to_db("seen_entities", entity_info)

            if entity.id == self.specific_id:
                continue

            element_categories = self._get_categories_of_type(entity.type)
            print(element_categories)
            for category in element_categories:
                if category not in self.found_categories:
                    self.found_categories.append(category)

        print("found: " + str(self.found_categories))

            



