from .behaviour import Behaviour
from ..help_functions.Map import Map
from std_msgs.msg import String
from lhw_interfaces.msg._result import Result
from nav_msgs.msg import OccupancyGrid
from geometry_msgs.msg import PoseStamped

import numpy as np
from scipy.spatial.distance import euclidean 

from PIL import Image 

import os



METER_PER_PIXEL = 0.01

class GoToEntity(Behaviour):
    def __init__(self, node, args):
        super().__init__(node, args)
        self.node = node

        node.log.info("GoToEntity started")

        # ------------- State's properties --------------
        self.state_done = False

        self.specific_id = args.id

        self.state_name = String()
        self.state_name.data = "GO_TO_ENTITY"

        self.goal_reached = False
        self.relative_pose = False

        goal_entity = self.node.db.get_entity(self.specific_id)
        
        self.goal_pose = self._position_to_pose(goal_entity["position"])
        self.move_robot_to_pose(self.goal_pose)

        self.run_timer = self.node.create_timer(1, self.run_behaviour_loop) 

        #TEMPORARY
        self.moving_to_goal_counter = 5

    def run_behaviour_loop(self):

        if self.state_done or self._behaviour_timeout(): 
            self.run_timer.cancel()
            self.stop_robot()
            self.send_result()
            return
        self.node.log.info("GoToEntity looop")

        if self.relative_pose:
            self.move_robot_to_relative_pose(relative_pose)

        #TEMPORARY
        self.moving_to_goal_counter -= 1
        if not self.moving_to_goal_counter:
            self.navigate_to_pose_done_callback("done")
        

    def entities_callback(self, data):
        
        for entity in data.entities:
            if entity.id == self.specific_id:
                self.relative_pose = self._relative_xyz_to_relative_pose(entity.xyz)
                
    
    def navigate_to_pose_done_callback(self, result):
        self.state_done = True


    

