from .behaviour import Behaviour
from std_msgs.msg import String
from geometry_msgs.msg import Twist
from lhw_interfaces.msg._result import Result


class HaveAConversation(Behaviour):
    def __init__(self, node, args):
        super().__init__(node, args)
        self.node = node
        node.log.info("HaveAConversation started")

        self.stop_intention = args.type
        at_start = args.at_start
        self.stop_intention_detected = False

        # ------------- Behaviour's properties --------------
        self.state_name = String()
        self.state_name.data = "SPEECH_WITH_PERSON"
        print(at_start)
        self.say(at_start)

        self.run_timer = self.node.create_timer(1, self.run_behaviour_loop) 

    def run_behaviour_loop(self):
        if self.stop_intention_detected or self._behaviour_timeout():
            self.run_timer.cancel()
            self.node.log.info("Done with conversation")            
            self.send_result()
            return
            
    def response_callback(self, data):
        
        if data.intention == self.stop_intention:
            self.stop_intention_detected = True

        for parameter in data.parameters:
            self._add_to_db("nlp_parameters", parameter)

        self.say(data.response)


        

        
        return False

    