import rclpy
from rclpy.node import Node

from std_msgs.msg import String
from lhw_interfaces.msg import Response, Event

'''

OBS! This node is only for testing. 

'''


class Tester(Node):

    def __init__(self):
        super().__init__('DFNOde')

        self.publisher_ = self.create_publisher(Response, 'dialogflow_response', 10)
        response_sub = self.create_subscription(Event, 'nlp_event', self.event_callback, 1)

    def send_dialogflow_msg(self, response, recognized_text = ""):
        msg = Response()
        msg.source = Response.DIALOGFLOW
        msg.recognized_text = recognized_text
        msg.response = response
        msg.confidence = 0.0
        self.publisher_.publish(msg)
        self.get_logger().info('Publishing: "%s"' % msg)

    def event_callback(self, data):
        self.get_logger().info('Received: "%s"' % data)
        self.get_logger().info('Sending event')
        self.get_logger().info('Receiving response from dialogflow')
        self.send_dialogflow_msg("Thank you for your event")



def main(args=None):
    rclpy.init(args=args)
    ros_node = Tester()
    rclpy.spin(ros_node)
    rclpy.shutdown()


if __name__ == '__main__':
    main()