import rclpy
from rclpy.node import Node

from std_msgs.msg import String
from lhw_interfaces.msg import Response, Event

'''

OBS! This node is only for testing.

'''

class Tester(Node):

    def __init__(self):
        super().__init__('GPTNode')
        self.publisher_ = self.create_publisher(Response, 'gpt_response', 10)
        dialogflow_sub = self.create_subscription(Response, 'dialogflow_response', self.dialogflow_callback, 1)
        say_sub = self.create_subscription(String, 'say', self.say_callback, 1)
        

    def send_gpt_msg(self, response):
        msg = Response()
        msg.source = Response.GPT
        msg.response = response
        self.publisher_.publish(msg)
        self.get_logger().info('Publishing: "%s"' % msg)

    def dialogflow_callback(self, data):
        self.get_logger().info('GPT Received: "%s"' % data)
        self.send_gpt_msg("Hi from GPT")

    def say_callback(self, data):
        message = data.data
        # Save message for Machine learning



def main(args=None):
    rclpy.init(args=args)
    ros_node = Tester()
    rclpy.spin(ros_node)
    rclpy.shutdown()


if __name__ == '__main__':
    main()