import py_trees

root = py_trees.composites.Parallel(name="Root", policy=py_trees.common.ParallelPolicy.SuccessOnAll(synchronize=True))
topics2bb = py_trees.composites.Sequence(name="Topics2BB")
scan2bb = Scan2BB(name="Scan2BB") #CONDITION
cancel2bb = Cancel2BB(name="Cancel2BB") #ACTION
battery2bb = Battery2BB(name="Battery2BB") #CONDITION

tasks = py_trees.composites.Selector(name="Tasks")
flash_red = FlashRed(name="Flash Red") #ACTION
scan = py_trees.composites.Sequence(name="Scan")
send_result = SendResult(name="Send Result") #ACTION
scan_QUESTION = Scan_QUESTION(name="Scan?") #CONDITION
scan_or_die = py_trees.composites.Selector(name="Scan or Die")
ere_we_go = py_trees.composites.Sequence(name="Ere We Go")
undock = UnDock(name="UnDock") #ACTION
scan_or_be_cancelled = py_trees.composites.Selector(name="Scan or Be Cancelled")
move_out_and_scan = py_trees.composites.Sequence(name="Move Out and Scan")
move_home = MoveHome(name="Move Home") #ACTION
scanning = py_trees.composites.Parallel(name="Scanning", policy=py_trees.common.ParallelPolicy.SuccessOnAll(synchronize=True))
rotate = Rotate(name="Rotate") #ACTION
flash_blue = FlashBlue(name="Flash Blue") #ACTION
context_switch = ContextSwitch(name="Context Switch") #ACTION

move_out = MoveOut(name="Move Out") #ACTION
result2bb_succeeded = Result2BBsucceeded(name="Result2BB succeeded") #ACTION

cancelling_QUESTION = py_trees.composites.Sequence(name="Cancelling?")
cancel_QUESTION = Cancel_QUESTION(name="Cancel?") #CONDITION
result2bb_cancelled = Result2BBcancelled(name="Result2BB cancelled") #ACTION


dock = Dock(name="Dock") #ACTION
pause = Pause(name="Pause") #ACTION
flash_green = FlashGreen(name="Flash Green") #ACTION
celebrate = py_trees.composites.Parallel(name="Celebrate", policy=py_trees.common.ParallelPolicy.SuccessOnSelected(children=[pause, flash_green], synchronize=True))

celebrate = py_trees.composites.Parallel(name="Celebrate", policy=py_trees.common.ParallelPolicy.SuccessOnSelected(children=[pause, flash_green], synchronize=True))

die = py_trees.composites.Sequence(name="Die")
notification = py_trees.composites.Parallel(name="Notification", policy=py_trees.common.ParallelPolicy.SuccessOnAll(synchronize=True))

result2bb_failed = Result2BBfailed(name="Result2BB failed") #ACTION



idle = py_trees.behaviours.Running(name="Idle")



cancelling_QUESTION.add_children([cancel_QUESTION, move_home, result2bb_cancelled])

celebrate.add_children([pause, flash_green])

die.add_children([notification, result2bb_failed])

ere_we_go.add_children([undock, scan_or_be_cancelled, dock, celebrate])

move_home = MoveHome(name="Move Home") #ACTION
move_out_and_scan.add_children([move_home, scanning, move_out, result2bb_succeeded])

pause = Pause(name="Pause") #ACTION
notification.add_children([pause, flash_red])

root.add_children([topics2bb, tasks])

scan.add_children([send_result, scan_QUESTION, scan_or_die])

scan_or_be_cancelled.add_children([move_out_and_scan, cancelling_QUESTION])

scan_or_die.add_children([ere_we_go, die])

scanning.add_children([rotate, flash_blue, context_switch])

flash_red = FlashRed(name="Flash Red") #ACTION
tasks.add_children([flash_red, scan, idle])

topics2bb.add_children([scan2bb, cancel2bb, battery2bb])



behaviour_tree = py_trees.trees.BehaviourTree(root=root)
behaviour_tree.setup(timeout=15)
try:
    behaviour_tree.tick_tock(
        period_ms=500,
        number_of_iterations=py_trees.trees.CONTINOUS_TICK_TOCK,
        pre_tick_handler=None,
        post_tick_handler=None
    )
except KeyboardInterrupt:
     behaviour_tree.interrupt()
