import py_trees

def receptionist():    
    root = py_trees.composites.Sequence(name="Root")
    is_head_touched = IsHeadTouched(name="Is Head Touched", node=node)
    wait = py_trees.timers.Timer(name="Wait", duration=5)
    tell_referee_to_open_door = Say(name="Tell Referee To Open Door", node=node)
    greet_person_subtree = greet_person(node=node)
    tell_person_to_follow = Say(name="Tell Person To Follow", node=node)
    look_down = PepperTiltHead(name="Look Down", node=node)
    move_to_sofa = MoveToPoint(name="Move To Sofa", node=node)
    pepper_center_head = PepperCenterHead(name="Pepper Center Head", node=node)
    at_sofa_seq = py_trees.composites.Sequence(name="At Sofa Seq")
    intros_wait_sel = py_trees.composites.Selector(name="Intros Wait Sel")
    all_people_introduced = IsEveryoneIntroduced(name="All People Introduced", node=node)
    introduce_person = py_trees.composites.Sequence(name=" Introduce person")
    get_face_pixel = GetFacePixelCoordinate(name="Get Face Pixel", node=node)
    point_at_person = PointAtPixel(name="Point At Person", node=node)
    say_name_of_person = Say(name="Say Name Of Person", node=node)
    const_fail = py_trees.behaviours.Failure(name="Const Fail")
    
    introduce_retry = Standby(name="Introduce Retry", node=node)
    
    empty_seat_sel = py_trees.composites.Selector(name="Empty Seat Sel")
    successful_seating = py_trees.composites.Sequence(name="Successful Seating")
    get_couch_gap_pixel = CalculateGapPointLocation(name="Get Couch Gap Pixel", node=node)
    point_at_empty_seat = PointAtPixel(name="Point At Empty Seat", node=node)
    tell_person_to_sit = Say(name="Tell Person To Sit", node=node)
    
    unsuccessful_seating = py_trees.composites.Sequence(name="Unsuccessful Seating")
    say_there_is_no_seat = Say(name="Say There Is No Seat", node=node)
    
    
    
    move_to_door = MoveToPoint(name="Move To Door", node=node)
    
    
    at_sofa_seq.add_children([intros_wait_sel, empty_seat_sel])
    
    empty_seat_sel.add_children([successful_seating, unsuccessful_seating])
    
    introduce_person.add_children([get_face_pixel, point_at_person, say_name_of_person, const_fail])
    
    intros_wait_sel.add_children([all_people_introduced, introduce_person, introduce_retry])
    
    root.add_children([is_head_touched, wait, tell_referee_to_open_door, greet_person_subtree, tell_person_to_follow, look_down, move_to_sofa, pepper_center_head, at_sofa_seq, move_to_door])
    
    successful_seating.add_children([get_couch_gap_pixel, point_at_empty_seat, tell_person_to_sit])
    
    unsuccessful_seating.add_child(say_there_is_no_seat)
    return root