import os
from glob import glob
from setuptools import setup

package_name = 'lhw_intelligence'

setup(
    name=package_name,
    version='0.0.0',
    packages=[package_name],
    data_files=[
        ('share/ament_index/resource_index/packages',
            ['resource/' + package_name]),
        ('share/' + package_name, ['package.xml']),
        (os.path.join('share', package_name), glob('launch/*.launch.py'))
    ],
    install_requires=['setuptools'],
    zip_safe=True,
    maintainer='Axel Wickman',
    maintainer_email='axelwickm@gmail.com',
    description='General AI and task state machines',
    license='MIT',
    tests_require=['pytest'],
    entry_points={
        'console_scripts': [
            'ai_core = lhw_intelligence.ai_core:main',
            'find_person = lhw_intelligence.find_person:main',
            'fake_dialogflow = lhw_intelligence.fake_dialogflow:main',
            'fake_gpt = lhw_intelligence.fake_gpt:main',
            'transitions = lhw_intelligence.states.emotional_pepper:main',
            'py_tree = lhw_intelligence.py_tree:main',
            'battery_check_tree = lhw_intelligence.battery_check_tree:main'
        ],
    },
)
"""
    scripts=[
        'lhw_intelligence/behaviour.py',
    ]+glob('lhw_intelligence/behaviours/*.py'),
            'console_scripts': [
            'ai_core = lhw_intelligence.ai_core:main',
            'find_person = lhw_intelligence.find_person:main'
        ],
"""