within LiUHomeWreckers;

model Pepper
  ROSPlug.ROS_Node ROS_Node1(node_name = "goal_ai") annotation(Placement(visible = true, transformation(origin = {0, 30}, extent = {{-10, -7}, {10, 7}}, rotation = 0)));
  ROSPlug.Publisher goalPublisher(topic = "sm_goal", datatype = "lhw_interfaces/Goal", msgSitePackageURI = "file:///opt/ros1_lhw_catkin_ws/devel/lib/python3/dist-packages") annotation(Placement(visible = true, transformation(origin = {-35, -0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  ROSPlug.Subscriber feedbackSubscriber(topic = "sm_feedback") annotation(Placement(visible = true, transformation(origin = {40, 15}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  ROSPlug.Subscriber resultSubscriber(topic = "sm_result") annotation(Placement(visible = true, transformation(origin = {40, -15}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Interfaces.AiCoreOut aiCoreOut annotation(Placement(visible = true, transformation(origin = {0, -65}, extent = {{-15, -9}, {15, 9}}, rotation = 0), iconTransformation(origin = {120, 100}, extent = {{-44.831, -44.831}, {44.831, 44.831}}, rotation = -90)));
  Modelica.Blocks.Sources.BooleanExpression booleanExpression1 annotation(Placement(visible = true, transformation(origin = {-70, -5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(ROS_Node1.rosNodeConnector1, goalPublisher.subscriberPublisherConnector1) annotation(Line(visible = true, origin = {-8.241, 8}, points = {{8.241, 16}, {8.241, -8}, {-16.483, -8}}));
  connect(ROS_Node1.rosNodeConnector1, feedbackSubscriber.subscriberPublisherConnector1) annotation(Line(visible = true, origin = {9.833, 18}, points = {{-9.833, 6}, {-9.833, -3}, {19.667, -3}}));
  connect(ROS_Node1.rosNodeConnector1, resultSubscriber.subscriberPublisherConnector1) annotation(Line(visible = true, origin = {9.833, -2}, points = {{-9.833, 26}, {-9.833, -13}, {19.667, -13}}));
  resultSubscriber.message1.message = aiCoreOut.pepperInfo.result;
  feedbackSubscriber.message1.message = aiCoreOut.pepperInfo.feedback;
  aiCoreOut.pepperInfo.goal = goalPublisher.message1.message;
  connect(booleanExpression1.y, goalPublisher.trigger) annotation(Line(visible = true, origin = {-51.667, -5}, points = {{-7.333, 0}, {7.333, 0}}, color = {255, 0, 255}));
  annotation(Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-150, -100}, {150, 350}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Text(visible = true, origin = {0, 242.613}, textColor = {64, 64, 64}, extent = {{-150, 110}, {150, 150}}, textString = "%name"), Bitmap(visible = true, origin = {2.728, 124.609}, fileName = "modelica://LiUHomeWreckers.Pepper/icons/pepper.png", imageSource = "", extent = {{-150.522, -219.882}, {150.522, 219.882}})}));
end Pepper;
