import os
from glob import glob
from setuptools import setup

package_name = 'lhw_motion'

setup(
    name=package_name,
    version='0.0.0',
    packages=[package_name],
    data_files=[
        ('share/ament_index/resource_index/packages',
            ['resource/' + package_name]),
        ('share/' + package_name, ['package.xml']),
        (os.path.join('share', package_name), glob('launch/*.launch.py')),
        (os.path.join("share", package_name, "maps"), glob("maps/*")),
        (os.path.join("share", package_name, "config"), glob("config/*"))
    ],
    install_requires=['setuptools'],
    zip_safe=True,
    maintainer='Simon Wijk Stranius',
    maintainer_email='simon@simonws.se',
    description='Controls anything to do with motors, as well as spatial navigation.',
    license='MIT',
    tests_require=['pytest'],
    entry_points={
        'console_scripts': [
            'motion_behaviours = lhw_motion.motion_behaviours:main',
            'room_navigation = lhw_motion.room_navigation:main'
        ],
    },
)
