
import text2emotion as t2e
from EventT2E import EventT2E

class NodeText2Emotion1():
    def generateEventT2E(self, source_id, speaker_id, emotion_dict):
        emotions = ["Happy", "Angry", "Surprise", "Sad", "Fear"]
        emotion_sum = 0
        strongest_emotion_intensity = 0
        strongest_emotion = "Neutral"
        for e in emotions:
            e_intensity = emotion_dict[e]
            emotion_sum += e_intensity
            if e_intensity > strongest_emotion_intensity:
                strongest_emotion_intensity = e_intensity
                strongest_emotion = e
        emotion_sum = emotion_sum if emotion_sum > 0 else 1  # NEW CODE

        msg_emotion = EventT2E()
        msg_emotion.source_id = source_id
        msg_emotion.speaker_id = speaker_id  # Integrate with vision id

        msg_emotion.angry = float(emotion_dict['Angry']) / emotion_sum
        msg_emotion.disgust = float(-1) / emotion_sum
        msg_emotion.fear = float(emotion_dict['Fear']) / emotion_sum
        msg_emotion.happy = float(emotion_dict['Happy'])
        msg_emotion.neutral = (1.0 - (emotion_sum / 5)) / emotion_sum  # This might work
        msg_emotion.sad = float(emotion_dict['Sad']) / emotion_sum
        msg_emotion.surprised = float(emotion_dict['Surprise']) / emotion_sum

        msg_emotion.dominant_emotion = strongest_emotion.lower()
        return msg_emotion

    def text_2_emotion(self, msg):
        emotion_dict = t2e.get_emotion(str(msg))
        msg_emotion = self.generateEventT2E(
            source_id=1,
            speaker_id='',
            emotion_dict=emotion_dict
        )
        return msg_emotion

