"""
    Takes snippets of audio from microphone, sends it to Google's DialogFlow API
    and forwards the extracted intent, etc.
"""

import rclpy
from rclpy.node import Node
from std_msgs.msg import String, Int16
from lhw_interfaces.msg import Audio
from lhw_interfaces.msg import Response
from lhw_interfaces.msg import Parameter
import dialogflow_v2 as dialogflow
from collections import deque
from google.oauth2 import service_account
import os
import time
import pygame


#import scipy.io.wavfile as wavf
import numpy as np


#import pyaudio
#import wave
#import sys
#import threading



class DialogFlowCommunicator(Node):
    def __init__(self):
        #play()
        super().__init__('buffer')

        self.audio_chunk_queue = []    # Buffer where callback stores audio samples coming from audio_topic. Audio chunks are later removed from it and sent to Dialogflow
        self.max_queue_size = 1000000000
        
        self.buffer_sub = self.create_subscription(Audio, 'microphone_buffer', self.audio_cb, 10)
        self.response_pub = self.create_publisher(Response, 'response', 10)
        self.log = self.get_logger()
        self.log.warn(self.__class__.__name__+" has not yet been implemented.")  # TODO
        self.buffer_pub = self.create_publisher(Int16, "buffer", 10)

    def audio_cb(self, audio_msg):
        
        chunk = np.array(audio_msg.data, dtype=np.int16)
        count = 0 
        for bit in chunk[::3]:
            #count += 1
            #if count == 3:
            msg = Int16()
                #print(type(bit))

            msg.data = bit.item()
            self.buffer_pub.publish(msg) 
            #count = 0
        
        return

        chunk = np.array(audio_msg.data) 
        sound = pygame.sndarray.make_sound(chunk)
        sound.play()
        return

        self.audio_chunk_queue.extend(audio_msg.data)
        if len(self.audio_chunk_queue) == 5*8192:
            chunk = np.array(self.audio_chunk_queue, dtype=np.int16) 
            print(str(chunk))
            print(str(type(chunk)))
            print(str(len(chunk)))
            sound = pygame.sndarray.make_sound(chunk)

            #print("Before play")
            #raw_input()
            sound.play()
        elif len(self.audio_chunk_queue) > 5*8192:
            self.audio_chunk_queue = []


def main(args=None):
    rclpy.init(args=args)
    dialogflow_node = DialogFlowCommunicator()
    
    rclpy.spin(dialogflow_node)
    dialogflow_node.destroy_node()
    rclpy.shutdown()



if __name__ == '__main__':
    main()


