#!/usr/bin/env python
# -*- coding: utf-8 -*-
import sys
from naoqi import ALProxy
import random
import cmd
import time
import readline
import rlcompleter

class Recorder():
    """ Simple interactive talk program """

    def __init__(self, robot):
        #super(Talker, self).__init__()
        #cmd.Cmd.__init__(self)

        try:
            self._posture =  ALProxy("ALRobotPosture", robot, 9559)
        except Exception as e:
            print("Error creating proxy to ALPosture for "+robot)
            print(e.message)
            exit(0)
        try:
            self._tts = ALProxy("ALTextToSpeech", robot, 9559)
        except Exception as e:
            print("Error creating proxy to ALTextToSpeech for " + robot)
            print(e.message)
            exit(0)
        try:
            self._talk = ALProxy("ALAnimatedSpeech", robot, 9559)
        except Exception as e:
            print("Error creating proxy to ALAnimatedSpeech for " + robot)
            print(e.message)
            exit(0)
        try:
            self._audio = ALProxy("ALAudioDevice", robot, 9559)
        except Exception as e:
            print("Error creating proxy to ALAudioDevice for " + robot)
            print(e.message)
            exit(0)
        try:
            self._motion = ALProxy("ALMotion", robot, 9559)
        except Exception as e:
            print("Error creating proxy to ALMotion for " + robot)
            print(e.message)
            exit(0)
        try:
            self._behavior = ALProxy("ALBehaviorManager", robot, 9559)
        except Exception as e:
            print("Error creating proxy to ALBehaviorManager")
            print(e.message)
            exit(0)

        try:
            self._tablet = ALProxy("ALTabletService", robot, 9559)
        except Exception as e:
            print("Error creating proxy to ALTabletService")
            print(e.message)
            exit(0)

        

        try:
            self._recorder = ALProxy("ALAudioRecorder", robot, 9559)
        except Exception as e:
            print("Error creating proxy to ALTabletService")
            print(e.message)
            exit(0)

        self._recorder.startMicrophonesRecording("/home/nao/pepper.wav", "wav", 48000, [0,0,1,0])

        time.sleep(10)
        self._recorder.stopMicrophonesRecording()

        ###################

        #self._tablet.showWebview("http://198.18.0.1/apps/peppername")

        ################


    ################################

if __name__ == "__main__":
        
    Recorder("192.168.0.226")
