import os
from glob import glob
from setuptools import setup

package_name = 'lhw_nlp'

setup(
    name=package_name,
    version='0.0.0',
    packages=[package_name],
    data_files=[
        ('share/ament_index/resource_index/packages',
            ['resource/' + package_name]),
        ('share/' + package_name, ['package.xml']),
        (os.path.join('share', package_name), glob('launch/*.launch.py'))
    ],
    install_requires=['setuptools'],
    zip_safe=True,
    maintainer='Axel Wickman',
    maintainer_email='axelwickm@gmail.com',
    description='Receives and outputs verbal information.',
    license='MIT',
    tests_require=['pytest'],
    entry_points={
        'console_scripts': [
            'dialogflow = lhw_nlp.dialogflow:main',
            'gpt = lhw_nlp.gpt:main',
            'speech_to_text = lhw_nlp.speech_to_text:main',
            'wolfram_nlp = lhw_nlp.wolfram_nlp:main',
            'sound_tool = lhw_nlp.sound_tool:main',
            'tone_analysis = lhw_nlp.tone_analysis:main',
            'sentiment_analysis = lhw_nlp.sentiment_analysis:main',
            'speak_rate_analysis = lhw_nlp.speak_rate_analysis:main',
            'bufferpublisher = lhw_nlp.bufferpublisher:main',
            'text_2_emotion_node_1 = lhw_nlp.text_2_emotion_1:main',
            'text_2_emotion_node_2 = lhw_nlp.text_2_emotion_2:main',
            'nlp_emotion_core = lhw_nlp.nlp_emotion_core:main',
        ],
    },
)
