#ifndef LHW_QI__ANIMATED_SPEECH_COMPONENT_HPP_
#define LHQ_QI__ANIMATED_SPEECH_COMPONENT_HPP_

#include "lhw_qi/visibility_control.h"

#include <std_msgs/msg/string.hpp>
#include <rclcpp/rclcpp.hpp>

#include <qi/applicationsession.hpp>
#include <qi/anyobject.hpp>


namespace lhw_qi
{

  class AnimatedSpeech : public rclcpp::Node
  {
  public:
    LHW_QI_PUBLIC
    explicit AnimatedSpeech(const rclcpp::NodeOptions & options);
    void initiate(qi::SessionPtr session);

  private:
    rclcpp::Subscription<std_msgs::msg::String>::SharedPtr say_sub_;
    OnSetParametersCallbackHandle::SharedPtr callback_handler_;
    qi::SessionPtr session_;
    qi::AnyObject animated_speech_service_;
    qi::AnyObject audio_device_service_;
    qi::AnyObject speaking_movement_service_;
    double speed_, pitch_;
    rcl_interfaces::msg::SetParametersResult param_change_callback(const std::vector<rclcpp::Parameter> & parameters);
  
  };

}  // namespace lhw_qi

#endif  // LHW_QI__ANIMATED_SPEECH_COMPONENT_HPP_
