#ifndef LHW_QI__JOINT_STATES_COMPONENT_HPP_
#define LHW_QI__JOINT_STATES_COMPONENT_HPP_

#include "lhw_qi/visibility_control.h"

#include <sensor_msgs/msg/joint_state.hpp>
#include <rclcpp/rclcpp.hpp>

#include <qi/anyobject.hpp>
#include <qi/applicationsession.hpp>



namespace lhw_qi
{
  class JointStates : public rclcpp::Node
  {
  public:
    LHW_QI_PUBLIC
    explicit JointStates(const rclcpp::NodeOptions & options);
    void initiate(qi::SessionPtr session);
  private:
    qi::SessionPtr session_;
    qi::AnyObject motion_service_;
    rclcpp::Publisher<sensor_msgs::msg::JointState>::SharedPtr joint_states_pub_;
    sensor_msgs::msg::JointState joint_states_msg_;
    std::vector<qi::Future<std::vector<double>>> joint_states_future_vector_;
    rclcpp::TimerBase::SharedPtr request_states_timer_;
    rclcpp::TimerBase::SharedPtr publish_received_states_timer_;
  };

} // namespace lhw_qi

#endif // !LHW_QI__JOINT_STATES_COMPONENT_HPP_
