#ifndef LHW_QI__LEDS_COMPONENT_HPP_
#define LHW_QI__LEDS_COMPONENT_HPP_

#include "lhw_qi/visibility_control.h"

#include <std_msgs/msg/bool.hpp>
#include <std_msgs/msg/color_rgba.hpp>
#include <std_msgs/msg/float64.hpp>
#include <rclcpp/rclcpp.hpp>

#include <qi/anyobject.hpp>
#include <qi/applicationsession.hpp>

namespace lhw_qi
{

  class Leds : public rclcpp::Node
  {
  public:
    LHW_QI_PUBLIC
    explicit Leds(const rclcpp::NodeOptions & options);
    void initiate(qi::SessionPtr session);
  private:
    qi::SessionPtr session_;
    qi::AnyObject leds_service_;
    rclcpp::Subscription<std_msgs::msg::ColorRGBA>::SharedPtr eye_color_sub_;
    rclcpp::Subscription<std_msgs::msg::Float64>::SharedPtr eye_angle_sub_;
    rclcpp::Subscription<std_msgs::msg::Float64>::SharedPtr ear_angle_sub_;
    rclcpp::Subscription<std_msgs::msg::Float64>::SharedPtr ear_percentage_sub_;
    rclcpp::Subscription<std_msgs::msg::Bool>::SharedPtr state_sub_;
  };

}  // namespace lhw_qi

#endif  // LHW_QI__LEDS_COMPONENT_HPP_
