#ifndef LHW_QI__MICROPHPNE_COMPONENT_HPP_
#define LHW_QI__MICROPHPNE_COMPONENT_HPP_

#include "lhw_qi/visibility_control.h"

#include <std_msgs/msg/bool.hpp>
#include <std_msgs/msg/float64.hpp>
#include <std_msgs/msg/int16.hpp>
#include <rclcpp/rclcpp.hpp>

#include <qi/anyobject.hpp>
#include <qi/applicationsession.hpp>

#include <lhw_interfaces/msg/audio.hpp>
#include <vector>
#include <fstream>
#include <iostream>
namespace lhw_qi
{

  class Microphone : public rclcpp::Node
  {
  public:
    LHW_QI_PUBLIC
    explicit Microphone(const rclcpp::NodeOptions & options);
    void initiate(qi::SessionPtr session, boost::shared_ptr<Microphone> microphone_ptr);
    void init(void);
    virtual ~Microphone(void);
    void processRemote(  const int & nbOfChannels, 
              const int & nbrOfSamplesByChannel, 
              const qi::AnyValue & timestamp, 
              const qi::AnyValue & buffer);
  private:
    //rclcpp::Publisher<std_msgs::msg::Int16>::SharedPtr pub_;
    rclcpp::Publisher<lhw_interfaces::msg::Audio>::SharedPtr pub_;
    qi::SessionPtr session_;
    qi::AnyObject listener_;
    std::vector<uint8_t> chunk_;
    std::ofstream myfile; 
  };
  
}  // namespace lhw_qi



#endif  // LHW_QI__LEDS_COMPONENT_HPP_
