#ifndef LHW_QI__MOTION_COMPONENT_HPP_
#define LHW_QI__MOTION_COMPONENT_HPP_

#include "lhw_qi/visibility_control.h"

#include <std_msgs/msg/bool.hpp>
#include <std_msgs/msg/float64.hpp>
#include <geometry_msgs/msg/twist.hpp>
#include <rclcpp/rclcpp.hpp>
#include <lhw_interfaces/msg/robot_action.hpp>

#include <qi/anyobject.hpp>
#include <qi/applicationsession.hpp>

namespace lhw_qi
{

  class Motion : public rclcpp::Node
  {
  public:
    LHW_QI_PUBLIC
    explicit Motion(const rclcpp::NodeOptions & options);
    void initiate(qi::SessionPtr session);
  private:
    qi::SessionPtr session_;
    qi::AnyObject motion_service_;
    qi::AnyObject tracker_service_;
    rclcpp::Subscription<geometry_msgs::msg::Twist>::SharedPtr move_sub_;
    rclcpp::Subscription<geometry_msgs::msg::Twist>::SharedPtr move_to_sub_;
    rclcpp::Subscription<lhw_interfaces::msg::RobotAction>::SharedPtr robot_action_sub_;

  };

}  // namespace lhw_qi

#endif  // LHW_QI__LEDS_COMPONENT_HPP_
