#ifndef LHW_QI__ROBOT_POINT_COMPONENT_HPP_
#define LHW_QI__ROBOT_POINT_COMPONENT_HPP_

#include "lhw_qi/visibility_control.h"

#include <std_msgs/msg/string.hpp>
#include <geometry_msgs/msg/twist.hpp>
#include <rclcpp/rclcpp.hpp>
#include <lhw_interfaces/msg/robot_action.hpp>

#include <qi/anyobject.hpp>
#include <qi/applicationsession.hpp>

namespace lhw_qi
{

  class RobotPoint : public rclcpp::Node
  {
  public:
    LHW_QI_PUBLIC
    explicit RobotPoint(const rclcpp::NodeOptions & options);
    void initiate(qi::SessionPtr session);
  private:
    qi::SessionPtr session_;
    qi::AnyObject tracker_service_;
    //rclcpp::Subscription<lhw_interfaces::msg::RobotAction>::SharedPtr robot_point_sub_;
    int speed_;
  };

}  // namespace lhw_qi

#endif  // LHW_QI__LEDS_COMPONENT_HPP_
