#ifndef LHW_QI__SPEECH_RECOGNITION_COMPONENT_HPP_
#define LHQ_QI__SPEECH_RECOGNITION_HPP_

#include "lhw_qi/visibility_control.h"

#include <std_msgs/msg/string.hpp>
#include <rclcpp/rclcpp.hpp>

#include <qi/anyobject.hpp>
#include <qi/applicationsession.hpp>


namespace lhw_qi
{

  class SpeechRecognition : public rclcpp::Node
  {
  public:
    LHW_QI_PUBLIC
    explicit SpeechRecognition(const rclcpp::NodeOptions & options);
    void initiate(qi::SessionPtr session);
    ~SpeechRecognition();
  
  private:
    void word_cb(qi::AnyValue a);

    rclcpp::Publisher<std_msgs::msg::String>::SharedPtr pub_;
    qi::SessionPtr session_;
    qi::AnyObject asr_service_;
    qi::AnyObject asr_sub_;


  };

}  // namespace lhw_qi

#endif  // LHW_QI__SPEECH_RECOGNITION_COMPONENT_HPP_
