
#ifndef LHW_QI__TABLET_COMPONENT_HPP_
#define LHQ_QI__TABLET_COMPONENT_HPP_

#include "lhw_qi/visibility_control.h"

#include <std_msgs/msg/string.hpp>
#include <rclcpp/rclcpp.hpp>

#include <qi/anyobject.hpp>
#include <qi/applicationsession.hpp>
#include "naoqi_bridge_msgs/srv/set_string.hpp"
#include "std_srvs/srv/trigger.hpp"


namespace lhw_qi
{
  
  class Tablet : public rclcpp::Node
  {
  public:
    LHW_QI_PUBLIC
    explicit Tablet(const rclcpp::NodeOptions & options);
    void initiate(qi::SessionPtr session);
    
  private:
    qi::SessionPtr session_;
    qi::AnyObject tablet_service_;
    // WEB VIEW
    rclcpp::Service<naoqi_bridge_msgs::srv::SetString>::SharedPtr url_service;
    rclcpp::Service<std_srvs::srv::Trigger>::SharedPtr hide_web_service;
    rclcpp::Service<std_srvs::srv::Trigger>::SharedPtr reload_page_service;
    // IMAGE
    rclcpp::Service<naoqi_bridge_msgs::srv::SetString>::SharedPtr show_image_service;
    rclcpp::Service<std_srvs::srv::Trigger>::SharedPtr hide_image_service;
    // VIDEO
    rclcpp::Service<naoqi_bridge_msgs::srv::SetString>::SharedPtr play_video_service;
    rclcpp::Service<std_srvs::srv::Trigger>::SharedPtr pause_video_service;
    rclcpp::Service<std_srvs::srv::Trigger>::SharedPtr stop_video_service;
    rclcpp::Service<std_srvs::srv::Trigger>::SharedPtr resume_video_service;
    rclcpp::Service<std_srvs::srv::Trigger>::SharedPtr pause_gif_service;
    rclcpp::Service<std_srvs::srv::Trigger>::SharedPtr resume_gif_service;
    // SYSTEM
    rclcpp::Service<std_srvs::srv::Trigger>::SharedPtr reset_tablet_service;
    rclcpp::Service<std_srvs::srv::Trigger>::SharedPtr hide_tablet_service;
  };

}  // namespace lhw_qi

#endif  // LHW_QI__TOUCH_COMPONENT_HPP_
