#ifndef LHW_QI__VISIBILITY_CONTROL_H_
#define LHW_QI__VISIBILITY_CONTROL_H_

#ifdef __cplusplus
extern "C"
{
#endif

// This logic was borrowed (then namespaced) from the examples on the gcc wiki:
//     https://gcc.gnu.org/wiki/Visibility

#if defined _WIN32 || defined __CYGWIN__
  #ifdef __GNUC__
    #define LHW_QI_EXPORT __attribute__ ((dllexport))
    #define LHW_QI_IMPORT __attribute__ ((dllimport))
  #else
    #define LHW_QI_EXPORT __declspec(dllexport)
    #define LHW_QI_IMPORT __declspec(dllimport)
  #endif
  #ifdef LHW_QI_BUILDING_DLL
    #define LHW_QI_PUBLIC LHW_QI_EXPORT
  #else
    #define LHW_QI_PUBLIC LHW_QI_IMPORT
  #endif
  #define LHW_QI_PUBLIC_TYPE LHW_QI_PUBLIC
  #define LHW_QI_LOCAL
#else
  #define LHW_QI_EXPORT __attribute__ ((visibility("default")))
  #define LHW_QI_IMPORT
  #if __GNUC__ >= 4
    #define LHW_QI_PUBLIC __attribute__ ((visibility("default")))
    #define LHW_QI_LOCAL  __attribute__ ((visibility("hidden")))
  #else
    #define LHW_QI_PUBLIC
    #define LHW_QI_LOCAL
  #endif
  #define LHW_QI_PUBLIC_TYPE
#endif

#ifdef __cplusplus
}
#endif

#endif  // LHW_QI__VISIBILITY_CONTROL_H_
