#include "lhw_qi/robot_point_component.hpp"


#define _USE_MATH_DEFINES
#include <cmath>
#include <string>
#include <vector>
#include <iostream>
#include <geometry_msgs/msg/twist.hpp>
#include <lhw_interfaces/msg/robot_action.hpp>

namespace lhw_qi
{

  RobotPoint::RobotPoint(const rclcpp::NodeOptions & options)
    : Node("robot_point", options)
  {
    /*
    auto robot_point_cb =
      [this](const typename lhw_interfaces::msg::RobotAction::SharedPtr msg) -> void
      {
        RCUTILS_LOG_INFO("Event detected!");
        //pointAt(effector, [x, y, z], speed), speed =[0, 1], effector = [RArm, LArm, Arms]
        // Default 

        if (msg->type == msg->POINT_ABS_RIGHT) {
          // Point right with right arm
          std::vector<float> position = {0.0f, -1.0f, 0.0f};
          tracker_service_.call<void>("pointAt", "RArm", position, 0, 0.3);
        }
        else if (msg->type == msg->POINT_ABS_STRAIGHT) {
          if (msg->right_arm) {
            // Point straight right arm
            std::vector<float> position= {1.0f, 0.0f, 0.0f};
            tracker_service_.call<void>("pointAt", "RArm", position, 0, 0.3);
          }
          else {
            // Point straight with left arm
            std::vector<float> position = {1.0f, 0.0f, 0.0f};
            tracker_service_.call<void>("pointAt", "LArm", position, 0, 0.3);
          }
        }
        else if (msg->type == msg->POINT_ABS_LEFT) {
          // Point left with left arm
          std::vector<float> position = {1.0f, 3.0f, 0.0f};
          tracker_service_.call<void>("pointAt", "LArm", position, 0, 0.3);
        }
        else {
          RCUTILS_LOG_INFO("WHAT ARE YOU DOING");
        }
      };

    // Create subscribers
    //robot_point_sub_ = create_subscription<lhw_interfaces::msg::RobotAction>("robot_action", 10, robot_point_cb);

  }*/
  }
  void RobotPoint::initiate(qi::SessionPtr session){
    session_ = session;
    speed_ = 0.3; // 'lagom'
    tracker_service_ = session_->service("ALTracker");
  }

}  // namespace lhw_qi

#include "rclcpp_components/register_node_macro.hpp"

// Register the component with class_loader.
// This acts as a sort of entry point, allowing the component to be discoverable when its library
// is being loaded into a running process.
RCLCPP_COMPONENTS_REGISTER_NODE(lhw_qi::RobotPoint)
