#include "lhw_qi/joint_states_component.hpp"

#include <rcutils/cmdline_parser.h>


int main(int argc, char * argv[])
{
  rclcpp::init(argc, argv);

  // Parse the command line options.
  auto ip = std::string("localhost");
  char * cli_option = rcutils_cli_get_option(argv, argv + argc, "-i");
  if (nullptr != cli_option) {
    ip = std::string(cli_option);
  }  
  auto port = std::string("9559");
  cli_option = rcutils_cli_get_option(argv, argv + argc, "-p");
  if (nullptr != cli_option) {
    port = std::string(cli_option);
  }

  // Connect to naoqi
  qi::ApplicationSession app(argc, argv, 0, "tcp://" + ip + ":" + port);  
  RCUTILS_LOG_INFO("Attempting connection to %s on port %s", ip.c_str(), port.c_str());
  app.startSession();
  qi::SessionPtr session = app.session();
  RCUTILS_LOG_INFO("Session started");

  auto joint_states = std::make_shared<lhw_qi::JointStates>(rclcpp::NodeOptions());
  joint_states->initiate(session);
  rclcpp::spin(joint_states);

  rclcpp::shutdown();
  return 0;
}
