#include "lhw_qi/microphone_component.hpp"

#include <rcutils/cmdline_parser.h>

template<typename T>
void do_release(typename boost::shared_ptr<T> const&, T*)
{
}

template<typename T>
typename std::shared_ptr<T> to_std(typename boost::shared_ptr<T> const& p)
{
    return
        std::shared_ptr<T>(
                p.get(),
                boost::bind(& do_release<T>, p, _1));

}

int main(int argc, char * argv[])
{
  rclcpp::init(argc, argv);

  // Parse the command line options.
  auto ip = std::string("localhost");
  char * cli_option = rcutils_cli_get_option(argv, argv + argc, "-i");
  if (nullptr != cli_option) {
    ip = std::string(cli_option);
  }
  auto port = std::string("9559");
  cli_option = rcutils_cli_get_option(argv, argv + argc, "-p");
  if (nullptr != cli_option) {
    port = std::string(cli_option);
  }

  // Connect to naoqi
  qi::ApplicationSession app(argc, argv, 0, "tcp://" + ip + ":" + port);
  RCUTILS_LOG_INFO("Attempting connection to %s on port %s", ip.c_str(), port.c_str());
  app.startSession();
  qi::SessionPtr session = app.session();
  RCUTILS_LOG_INFO("Session started");

  auto microphone = boost::make_shared<lhw_qi::Microphone>(rclcpp::NodeOptions());
  microphone->initiate(session, microphone);
  app.run();
  rclcpp::spin(to_std(microphone));
  
  rclcpp::shutdown();
  return 0;
}
