#NOTE: this is an old node from ros1, should be ported to ros2.
# It might be useful if pepper gives blurry images

import rospy
from sensor_msgs.msg import Image
from cv_bridge import CvBridge, CvBridgeError
from .sharpen_src import Predictor
import cv2
import numpy as np
import PIL.Image
import rospkg
import os
rospack = rospkg.RosPack()
root = os.path.join(rospack.get_path("lhw_vision"),"scripts/sharpen_resources")
os.chdir(root)
DEBUG = True

class SharpenNode:
    """
    Node that improves the quality of the incoming pepper images in several ways.
    """
    def __init__(self,weights_path = 'best_fpn.h5'):                        
        rospy.init_node('sharp_images', anonymous=True)
        self.camera_topic = "/darknet_ros/detection_image"#'/pepper_robot/camera/front/image_raw'
        self.bridge = CvBridge()
        self.publisher = rospy.Publisher('sharp_image', Image, queue_size=10)
        self.sharpener = Predictor(weights_path=weights_path)
        rospy.Subscriber(self.camera_topic,Image,self.sharpen_image)
        print("SharpenNode Activated Successfully, awaiting input...")
        rospy.spin()
    
    def sharpen_image(self,image):
        image = self.bridge.imgmsg_to_cv2(image, desired_encoding="rgb8")
        sharp_image = self.sharpener(image)
        sharp_image_msg = self.bridge.cv2_to_imgmsg(sharp_image, encoding="rgb8")
        self.publisher.publish(sharp_image_msg)
        if DEBUG:
            x = np.array(PIL.Image.fromarray(image).resize((960,720),resample=PIL.Image.BICUBIC))
            comparison = np.hstack((x,sharp_image))
            comparison = cv2.cvtColor(comparison,cv2.COLOR_RGB2BGR)
            cv2.imshow("sharpened image",comparison)
            cv2.waitKey(20)

if __name__=="__main__":
    node = SharpenNode()