#NOTE: this is an old node from ros1, should be ported to ros2.
# It might be useful if pepper gives blurry images

import rclpy
from rclpy.node import Node
from sensor_msgs.msg import Image,CompressedImage
from lhw_interfaces.msg import Entity, Entities
from builtin_interfaces.msg import Time
from cv_bridge import CvBridge, CvBridgeError
from .sharpen import Predictor
import cv2
import numpy as np
import PIL.Image
import os


DEBUG = False

class SharpenNode(Node):
    """
    Node that improves the quality of the incoming pepper images in several ways.
    """
    def __init__(self,weights_path = './src/lhw_vision/lhw_vision/sharpen/fpn_inception.h5'):
        super().__init__("sharpener")                        
        self.camera_topic = "images"
        self.bridge = CvBridge()
        self.log = self.get_logger()
        self.publisher = self.create_publisher(Image,'sharp_image', 10)
        self.sharpener = Predictor(self.log,weights_path=weights_path)
        self.image_sub = self.create_subscription(Image, '/image',
                                                     self.sharpen_image, 10)
        print("SharpenNode Activated Successfully, awaiting input...")
    
    def sharpen_image(self,image):
        self.log.info('Image in')
        image = self.bridge.imgmsg_to_cv2(image, desired_encoding="rgb8")
        sharp_image = self.sharpener(image)
        sharp_image_msg = self.bridge.cv2_to_imgmsg(sharp_image, encoding="rgb8")
        self.publisher.publish(sharp_image_msg)
        self.log.info('Sharp image out')

def main(args=None):
    rclpy.init(args=args)
    sharpen_node = SharpenNode()

    rclpy.spin(sharpen_node)

    sharpen_node.destroy_node()
    rclpy.shutdown()


if __name__ == '__main__':
    main()