def IoU(boxA, boxB):
	boxA, boxB = [int(a) for a in boxA], [int(b) for b in boxB]
	# determine the (x, y)-coordinates of the intersection rectangle
	xA = max(boxA[0], boxB[0])
	yA = max(boxA[1], boxB[1])
	xB = min(boxA[2], boxB[2])
	yB = min(boxA[3], boxB[3])
 
	# compute the area of intersection rectangle
	interArea = max(0, xB - xA + 1) * max(0, yB - yA + 1)
 
	# compute the area of both the prediction and ground-truth
	# rectangles
	boxAArea = (boxA[2] - boxA[0] + 1) * (boxA[3] - boxA[1] + 1)
	boxBArea = (boxB[2] - boxB[0] + 1) * (boxB[3] - boxB[1] + 1)
 
	# compute the intersection over union by taking the intersection
	# area and dividing it by the sum of prediction + ground-truth
	# areas - the interesection area
	assert boxAArea > 0,f'{boxAArea =}, {boxA=}'
	assert boxBArea > 0,f'{boxBArea =}, {boxB=}'

	iou = interArea / float(boxAArea + boxBArea - interArea)
 
	# return the intersection over union value
	return iou

def not_at_border(bbox,h,w,border_width=100):
	center = ((bbox[2]+bbox[0])/2,(bbox[3]-bbox[1])/2)
	a=border_width<center[0]
	b=center[0] < w - border_width
	c=border_width<center[1]
	d=center[1] < h - border_width
	return a and b and c and d

def big_enough(bbox, enough=1000):
	return ((bbox[2]-bbox[0])*(bbox[3]-bbox[1])) > enough