import os
from PIL import Image
import cv2
import glob
import numpy as np

def save_image(im,path):
    Image.fromarray(im).save(path)


def ims_to_video(im_path,vid_path):
    im_paths = glob.glob(im_path+'/*')
    fourcc = cv2.VideoWriter_fourcc('m', 'p', '4', 'v')
    writer = cv2.VideoWriter(vid_path, fourcc, 1.5, (640, 480))
    sorter = lambda x: int(os.path.basename(x).split("_")[-1][:-4])
    im_paths = sorted(im_paths,key = sorter)
    for im_path in im_paths:
        frame = Image.open(im_path)
        writer.write(cv2.cvtColor(np.array(frame), cv2.COLOR_RGB2BGR))        
    writer.release()

if __name__ == "__main__":
    import sys
    ims_to_video(sys.argv[1], sys.argv[2])