import os
from glob import glob
from setuptools import setup

package_name = 'lhw_vision'

setup(
    name=package_name,
    version='0.0.0',
    packages=[package_name],
    data_files=[
        ('share/ament_index/resource_index/packages',
            ['resource/' + package_name]),
        ('share/' + package_name, ['package.xml']),
        (os.path.join('share', package_name), glob('launch/*.launch.py')),
        (os.path.join('ui', package_name), glob('ui/*'))
    ],
    install_requires=['setuptools'],
    zip_safe=True,
    maintainer='Axel Wickman',
    maintainer_email='axelwickm@gmail.com',
    description='Visual data is identified and tracked here (does not play a role in localization)',
    license='MIT',
    tests_require=['pytest'],
    entry_points={
        'console_scripts': [
            'image_to_world_node = lhw_vision.image_to_world_node:main',
            'tracker_node = lhw_vision.tracker.tracker_node:main',
            'yolo_node = lhw_vision.yolo_node:main',
            'transform_node = lhw_vision.transform_node:main',
            'face_analysis = lhw_vision.face_analysis:main',
            'bytetrack_node = lhw_vision.bytetrack_node:main',
            'sharpen_node = lhw_vision.sharpen_node:main',
            'densesense = lhw_vision.densesense_wrapper:main',
            'youtube_node = lhw_vision.youtube_publisher:main',
            'webcam_node = lhw_vision.webcam_publisher:main',
            'visualizer = lhw_vision.visualizer:main',
            'debug_image_node = lhw_vision.debug_image_node:main',
            'debug_tracker_node = lhw_vision.debug_tracker_node:main',
            'depth_node = lhw_vision.depth_node:main',
        ],
    },
)
