import numpy as np
from lhw_vision.tracker.kalman import Kalman        
kal = Kalman()
ident = 1
Z = np.linspace(0,10,num=100)[:,None].reshape(25,4)
for z in Z[:-1]:
    kal.measurement_update(ident,z)
    kal.time_update(ident)
assert np.linalg.norm(kal.get_pos(ident)-Z[-1]) < 1e-4, f'Kalman filter prediction does not converge to true position norm: {np.linalg.norm(kal.get_pos(ident)-Z[-1])}'